/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package integer_division_operator;

/**
 *
 * @author sameldin
 */
import dataobjects.*;
import constants.*;
import sam_logger_services.SamLoggerClass;


public class IntegerDivisionOperator 
{
    public IntegerDivisionOperator()
    {
        // logging
        SamLoggerClass.writeToLog(new Exception().getStackTrace()[0].getMethodName(), new Exception().getStackTrace()[0].getClassName());            
    }
    /*
     * 
     * 
     */
    public IntegerDivisionOperatorDAO doIntegerDivision(int numerator, int denominator)
    {
        // logging
        SamLoggerClass.writeToLog(new Exception().getStackTrace()[0].getMethodName(), new Exception().getStackTrace()[0].getClassName());
        
        IntegerDivisionOperatorDAO localIntegerDivisionOperatorDAO = new IntegerDivisionOperatorDAO();
        // check for Zero Values
        if(0 == numerator)
        {
            localIntegerDivisionOperatorDAO.setNumerator(0);
            String localErrorMessage = "Numerator is Zero";
            if(0 == denominator)
            {
                localErrorMessage += "\nDenominator is Zero";
            }
            else
            {
                localIntegerDivisionOperatorDAO.setDenominator(denominator);
                //localIntegerDivisionOperatorDAO.setQuotient(0);
                //localIntegerDivisionOperatorDAO.setRemainder(0);                
            }
            localIntegerDivisionOperatorDAO.setErrorMessage(localErrorMessage);          
            return(localIntegerDivisionOperatorDAO);
        }
        if(0 == denominator)
        {
            localIntegerDivisionOperatorDAO.setDenominator(0);
            localIntegerDivisionOperatorDAO.setNumerator(numerator);
            localIntegerDivisionOperatorDAO.setErrorMessage("Denominator is Zero");          
            return(localIntegerDivisionOperatorDAO);
        }
        if(Math.abs(denominator) > Math.abs(numerator))
        {
            localIntegerDivisionOperatorDAO.setNumerator(numerator);
            localIntegerDivisionOperatorDAO.setDenominator(denominator);
            localIntegerDivisionOperatorDAO.setQuotient(0);
            localIntegerDivisionOperatorDAO.setRemainder(numerator);
            localIntegerDivisionOperatorDAO.setErrorMessage("Denominator is greater than Numerator");          
            return(localIntegerDivisionOperatorDAO);            
        }
        //==========================================
        // check for negative values
        boolean negativeDenominatorFlag = false;
        boolean negativeNumeratorFlag   = false;
        if(denominator < 0)
            negativeDenominatorFlag = true;
        if(numerator < 0)
            negativeNumeratorFlag = true;
        //==========================================
        // set the values for subtraction
        localIntegerDivisionOperatorDAO.setNumerator(numerator);
        localIntegerDivisionOperatorDAO.setDenominator(denominator);
        denominator = Math.abs(denominator);
        numerator   = Math.abs(numerator);
        int remainder = 0;
        int quotient  = 0;
        // do the subtraction
        while(numerator >= denominator)
        {
           numerator -= denominator;
           quotient++;
        }
        remainder = numerator;
        if(negativeNumeratorFlag)
        {
            if(negativeDenominatorFlag)
            {
                remainder *= IntegerDivisionOperatorConstants.NEGATIVE_ONE;                
                quotient  *= IntegerDivisionOperatorConstants.NEGATIVE_ONE;                
            }
            else
            {
                quotient *= IntegerDivisionOperatorConstants.NEGATIVE_ONE;                
            }
        }
        else
        {
            if(negativeDenominatorFlag)
            {
                quotient *= IntegerDivisionOperatorConstants.NEGATIVE_ONE;                               
            }
        }
        localIntegerDivisionOperatorDAO.setQuotient(quotient);
        localIntegerDivisionOperatorDAO.setRemainder(remainder);
        localIntegerDivisionOperatorDAO.setErrorMessage("No Error");          
        
        return(localIntegerDivisionOperatorDAO);
    }
    /**
     *
    */
    public static void main (String[] args)
    {
        System.out.println("=====  start =====================");
        IntegerDivisionOperator ss = new IntegerDivisionOperator();
        IntegerDivisionOperatorDAO toPrintIntegerDivisionOperatorDAO = ss.doIntegerDivision(12, -5);
        System.out.println("Numerator    = " + toPrintIntegerDivisionOperatorDAO.getNumerator());
        System.out.println("Denominator  = " + toPrintIntegerDivisionOperatorDAO.getDenominator());
        System.out.println("Quotient     = " + toPrintIntegerDivisionOperatorDAO.getQuotient());
        System.out.println("Remainder    = " + toPrintIntegerDivisionOperatorDAO.getRemainder());
        System.out.println("ErrorMessage : " + toPrintIntegerDivisionOperatorDAO.getErrorMessage());
        System.out.println("==========================");
        System.out.println("=========================="); 
        SamLoggerClass.writeToLog(new Exception().getStackTrace()[0].getMethodName(), new Exception().getStackTrace()[0].getClassName());
    }    
    
    
    
}
